Index: /branches/HiveStatistics/sources/.nuget/NuGet.targets
===================================================================
--- /branches/HiveStatistics/sources/.nuget/NuGet.targets	(revision 12551)
+++ /branches/HiveStatistics/sources/.nuget/NuGet.targets	(revision 12551)
@@ -0,0 +1,144 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+    <PropertyGroup>
+        <SolutionDir Condition="$(SolutionDir) == '' Or $(SolutionDir) == '*Undefined*'">$(MSBuildProjectDirectory)\..\</SolutionDir>
+
+        <!-- Enable the restore command to run before builds -->
+        <RestorePackages Condition="  '$(RestorePackages)' == '' ">true</RestorePackages>
+
+        <!-- Property that enables building a package from a project -->
+        <BuildPackage Condition=" '$(BuildPackage)' == '' ">false</BuildPackage>
+
+        <!-- Determines if package restore consent is required to restore packages -->
+        <RequireRestoreConsent Condition=" '$(RequireRestoreConsent)' != 'false' ">true</RequireRestoreConsent>
+
+        <!-- Download NuGet.exe if it does not already exist -->
+        <DownloadNuGetExe Condition=" '$(DownloadNuGetExe)' == '' ">true</DownloadNuGetExe>
+    </PropertyGroup>
+
+    <ItemGroup Condition=" '$(PackageSources)' == '' ">
+        <!-- Package sources used to restore packages. By default, registered sources under %APPDATA%\NuGet\NuGet.Config will be used -->
+        <!-- The official NuGet package source (https://www.nuget.org/api/v2/) will be excluded if package sources are specified and it does not appear in the list -->
+        <!--
+            <PackageSource Include="https://www.nuget.org/api/v2/" />
+            <PackageSource Include="https://my-nuget-source/nuget/" />
+        -->
+    </ItemGroup>
+
+    <PropertyGroup Condition=" '$(OS)' == 'Windows_NT'">
+        <!-- Windows specific commands -->
+        <NuGetToolsPath>$([System.IO.Path]::Combine($(SolutionDir), ".nuget"))</NuGetToolsPath>
+    </PropertyGroup>
+
+    <PropertyGroup Condition=" '$(OS)' != 'Windows_NT'">
+        <!-- We need to launch nuget.exe with the mono command if we're not on windows -->
+        <NuGetToolsPath>$(SolutionDir).nuget</NuGetToolsPath>
+    </PropertyGroup>
+
+    <PropertyGroup>
+        <PackagesProjectConfig Condition=" '$(OS)' == 'Windows_NT'">$(MSBuildProjectDirectory)\packages.$(MSBuildProjectName.Replace(' ', '_')).config</PackagesProjectConfig>
+        <PackagesProjectConfig Condition=" '$(OS)' != 'Windows_NT'">$(MSBuildProjectDirectory)\packages.$(MSBuildProjectName).config</PackagesProjectConfig>
+    </PropertyGroup>
+
+    <PropertyGroup>
+      <PackagesConfig Condition="Exists('$(MSBuildProjectDirectory)\packages.config')">$(MSBuildProjectDirectory)\packages.config</PackagesConfig>
+      <PackagesConfig Condition="Exists('$(PackagesProjectConfig)')">$(PackagesProjectConfig)</PackagesConfig>
+    </PropertyGroup>
+    
+    <PropertyGroup>
+        <!-- NuGet command -->
+        <NuGetExePath Condition=" '$(NuGetExePath)' == '' ">$(NuGetToolsPath)\NuGet.exe</NuGetExePath>
+        <PackageSources Condition=" $(PackageSources) == '' ">@(PackageSource)</PackageSources>
+
+        <NuGetCommand Condition=" '$(OS)' == 'Windows_NT'">"$(NuGetExePath)"</NuGetCommand>
+        <NuGetCommand Condition=" '$(OS)' != 'Windows_NT' ">mono --runtime=v4.0.30319 "$(NuGetExePath)"</NuGetCommand>
+
+        <PackageOutputDir Condition="$(PackageOutputDir) == ''">$(TargetDir.Trim('\\'))</PackageOutputDir>
+
+        <RequireConsentSwitch Condition=" $(RequireRestoreConsent) == 'true' ">-RequireConsent</RequireConsentSwitch>
+        <NonInteractiveSwitch Condition=" '$(VisualStudioVersion)' != '' AND '$(OS)' == 'Windows_NT' ">-NonInteractive</NonInteractiveSwitch>
+
+        <PaddedSolutionDir Condition=" '$(OS)' == 'Windows_NT'">"$(SolutionDir) "</PaddedSolutionDir>
+        <PaddedSolutionDir Condition=" '$(OS)' != 'Windows_NT' ">"$(SolutionDir)"</PaddedSolutionDir>
+
+        <!-- Commands -->
+        <RestoreCommand>$(NuGetCommand) install "$(PackagesConfig)" -source "$(PackageSources)"  $(NonInteractiveSwitch) $(RequireConsentSwitch) -solutionDir $(PaddedSolutionDir)</RestoreCommand>
+        <BuildCommand>$(NuGetCommand) pack "$(ProjectPath)" -Properties "Configuration=$(Configuration);Platform=$(Platform)" $(NonInteractiveSwitch) -OutputDirectory "$(PackageOutputDir)" -symbols</BuildCommand>
+
+        <!-- We need to ensure packages are restored prior to assembly resolve -->
+        <BuildDependsOn Condition="$(RestorePackages) == 'true'">
+            RestorePackages;
+            $(BuildDependsOn);
+        </BuildDependsOn>
+
+        <!-- Make the build depend on restore packages -->
+        <BuildDependsOn Condition="$(BuildPackage) == 'true'">
+            $(BuildDependsOn);
+            BuildPackage;
+        </BuildDependsOn>
+    </PropertyGroup>
+
+    <Target Name="CheckPrerequisites">
+        <!-- Raise an error if we're unable to locate nuget.exe  -->
+        <Error Condition="'$(DownloadNuGetExe)' != 'true' AND !Exists('$(NuGetExePath)')" Text="Unable to locate '$(NuGetExePath)'" />
+        <!--
+        Take advantage of MsBuild's build dependency tracking to make sure that we only ever download nuget.exe once.
+        This effectively acts as a lock that makes sure that the download operation will only happen once and all
+        parallel builds will have to wait for it to complete.
+        -->
+        <MsBuild Targets="_DownloadNuGet" Projects="$(MSBuildThisFileFullPath)" Properties="Configuration=NOT_IMPORTANT;DownloadNuGetExe=$(DownloadNuGetExe)" />
+    </Target>
+
+    <Target Name="_DownloadNuGet">
+        <DownloadNuGet OutputFilename="$(NuGetExePath)" Condition=" '$(DownloadNuGetExe)' == 'true' AND !Exists('$(NuGetExePath)')" />
+    </Target>
+
+    <Target Name="RestorePackages" DependsOnTargets="CheckPrerequisites">        
+        <Exec Command="$(RestoreCommand)"
+              Condition="'$(OS)' != 'Windows_NT' And Exists('$(PackagesConfig)')" />
+
+        <Exec Command="$(RestoreCommand)"
+              LogStandardErrorAsError="true"
+              Condition="'$(OS)' == 'Windows_NT' And Exists('$(PackagesConfig)')" />
+    </Target>
+
+    <Target Name="BuildPackage" DependsOnTargets="CheckPrerequisites">
+        <Exec Command="$(BuildCommand)"
+              Condition=" '$(OS)' != 'Windows_NT' " />
+
+        <Exec Command="$(BuildCommand)"
+              LogStandardErrorAsError="true"
+              Condition=" '$(OS)' == 'Windows_NT' " />
+    </Target>
+
+    <UsingTask TaskName="DownloadNuGet" TaskFactory="CodeTaskFactory" AssemblyFile="$(MSBuildToolsPath)\Microsoft.Build.Tasks.v4.0.dll">
+        <ParameterGroup>
+            <OutputFilename ParameterType="System.String" Required="true" />
+        </ParameterGroup>
+        <Task>
+            <Reference Include="System.Core" />
+            <Using Namespace="System" />
+            <Using Namespace="System.IO" />
+            <Using Namespace="System.Net" />
+            <Using Namespace="Microsoft.Build.Framework" />
+            <Using Namespace="Microsoft.Build.Utilities" />
+            <Code Type="Fragment" Language="cs">
+                <![CDATA[
+                try {
+                    OutputFilename = Path.GetFullPath(OutputFilename);
+
+                    Log.LogMessage("Downloading latest version of NuGet.exe...");
+                    WebClient webClient = new WebClient();
+                    webClient.DownloadFile("https://www.nuget.org/nuget.exe", OutputFilename);
+
+                    return true;
+                }
+                catch (Exception ex) {
+                    Log.LogErrorFromException(ex);
+                    return false;
+                }
+            ]]>
+            </Code>
+        </Task>
+    </UsingTask>
+</Project>
Index: /branches/HiveStatistics/sources/HeuristicLab 3.3 Services.sln
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab 3.3 Services.sln	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab 3.3 Services.sln	(revision 12551)
@@ -64,5 +64,4 @@
 	ProjectSection(SolutionItems) = preProject
 		.nuget\NuGet.Config = .nuget\NuGet.Config
-		.nuget\NuGet.exe = .nuget\NuGet.exe
 		.nuget\NuGet.targets = .nuget\NuGet.targets
 	EndProjectSection
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/HiveStatistics/FactTaskDao.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/HiveStatistics/FactTaskDao.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/HiveStatistics/FactTaskDao.cs	(revision 12551)
@@ -27,4 +27,14 @@
 namespace HeuristicLab.Services.Hive.DataAccess.Daos.HiveStatistics {
   public class FactTaskDao : GenericDao<Guid, FactTask> {
+
+    private static readonly TaskState[] CompletedStates = { TaskState.Finished, TaskState.Aborted, TaskState.Failed };
+
+    private Table<DimClient> DimClientTable {
+      get { return DataContext.GetTable<DimClient>(); }
+    }
+    private Table<DimJob> DimJobTable {
+      get { return DataContext.GetTable<DimJob>(); }
+    }
+
     private const string BatchDeleteQuery =
       @"DELETE FROM [statistics].[FactTask]
@@ -52,4 +62,26 @@
     }
 
+    public IQueryable<FactTask> GetTasksWithException() {
+      return Table.Where(x => x.Exception.Trim() != string.Empty);
+    }
+
+    public IQueryable<FactTask> GetByGroupId(Guid id) {
+      return from factTask in Table
+             join client in DimClientTable on factTask.LastClientId equals client.Id
+             where client.ResourceGroupId == id
+             select factTask;
+    }
+
+    public IQueryable<FactTask> GetByUserId(Guid id) {
+      return from factTask in Table
+             join job in DimJobTable on factTask.JobId equals job.JobId
+             where job.UserId == id
+             select factTask;
+    }
+
+    public IQueryable<FactTask> GetCompletedTasks() {
+      return Table.Where(x => CompletedStates.Contains(x.TaskState));
+    }
+
     public override void Delete(IEnumerable<Guid> ids) {
       string paramIds = string.Join(",", ids.Select(x => string.Format("'{0}'", x)));
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/SlaveDao.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/SlaveDao.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/SlaveDao.cs	(revision 12551)
@@ -55,4 +55,8 @@
     public IQueryable<Slave> GetAll() {
       return Entities;
+    }
+
+    public IQueryable<Slave> GetOnlineSlaves() {
+      return Entities.Where(x => x.SlaveState != SlaveState.Offline);
     }
 
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 12551)
@@ -227,7 +227,7 @@
     <Type Name="FactTask">
       <Column Name="TaskId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" CanBeNull="false" />
-      <Column Name="CalculatingTime" Storage="_TotalRuntime" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
-      <Column Name="WaitingTime" Storage="_TotalWaitingTime" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
-      <Column Name="TransferTime" Storage="_TotalTransferTime" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
+      <Column Name="CalculatingTime" Storage="_TotalRuntime" Type="System.Int64" DbType="INT NOT NULL" CanBeNull="false" />
+      <Column Name="WaitingTime" Storage="_TotalWaitingTime" Type="System.Int64" DbType="INT NOT NULL" CanBeNull="false" />
+      <Column Name="TransferTime" Storage="_TotalTransferTime" Type="System.Int64" DbType="INT NOT NULL" CanBeNull="false" />
       <Column Name="NumCalculationRuns" Type="System.Int32" DbType="Int NOT NULL" CanBeNull="false" />
       <Column Name="NumRetries" Storage="_NumFails" Type="System.Int32" DbType="Int NOT NULL" CanBeNull="false" />
@@ -240,5 +240,5 @@
       <Column Name="TaskState" Type="global::HeuristicLab.Services.Hive.DataAccess.TaskState" DbType="varchar(30)" CanBeNull="false" />
       <Column Name="Exception" Type="System.String" DbType="varchar(MAX)" CanBeNull="true" />
-      <Column Name="InitialWaitingTime" Storage="_InitialWaitingTimeMs" Type="System.Double" CanBeNull="false" />
+      <Column Name="InitialWaitingTime" Storage="_InitialWaitingTimeMs" Type="System.Int64" DbType="INT" CanBeNull="false" />
       <Column Name="StartTime" Type="System.DateTime" CanBeNull="true" />
       <Association Name="DimClient_FactTask" Member="DimClient" ThisKey="LastClientId" OtherKey="Id" Type="DimClient" IsForeignKey="true" />
@@ -287,8 +287,9 @@
       <Column Name="TotalMemory" Type="System.Int32" DbType="Int NOT NULL" CanBeNull="false" />
       <Column Name="CpuUtilization" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
-      <Column Name="TotalTimeIdle" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
-      <Column Name="TotalTimeOffline" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
-      <Column Name="TotalTimeUnavailable" Type="System.Double" DbType="Float NOT NULL" CanBeNull="false" />
+      <Column Name="IdleTime" Storage="_TotalTimeIdle" Type="System.Int64" DbType="INT NOT NULL" CanBeNull="false" />
+      <Column Name="OfflineTime" Storage="_TotalTimeOffline" Type="System.Int64" DbType="INT NOT NULL" CanBeNull="false" />
+      <Column Name="UnavailableTime" Storage="_TotalTimeUnavailable" Type="System.Int64" DbType="INT NOT NULL" CanBeNull="false" />
       <Column Name="SlaveState" Type="global::HeuristicLab.Services.Hive.DataAccess.SlaveState" DbType="VarChar(15)" CanBeNull="false" />
+      <Column Name="IsAllowedToCalculate" Type="System.Boolean" DbType="BIT" CanBeNull="false" />
       <Association Name="DimClient_FactClientInfo" Member="DimClient" ThisKey="ClientId" OtherKey="Id" Type="DimClient" IsForeignKey="true" />
       <Association Name="DimTime_FactClientInfo" Member="DimTime" ThisKey="Time" OtherKey="Time" Type="DimTime" IsForeignKey="true" />
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml.layout
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml.layout	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml.layout	(revision 12551)
@@ -277,8 +277,8 @@
       </nestedChildShapes>
     </classShape>
-    <classShape Id="053a5cff-b18a-4ee5-8d43-48ed5c5dcfad" absoluteBounds="2.625, 11, 2, 3.1170068359375005">
+    <classShape Id="053a5cff-b18a-4ee5-8d43-48ed5c5dcfad" absoluteBounds="2.625, 11, 2, 3.3093082682291666">
       <DataClassMoniker Name="/HiveDataContext/FactClientInfo" />
       <nestedChildShapes>
-        <elementListCompartment Id="0a1cc913-6636-455c-95b3-302f533527db" absoluteBounds="2.6399999999999997, 11.46, 1.9700000000000002, 2.5570068359375" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="0a1cc913-6636-455c-95b3-302f533527db" absoluteBounds="2.6399999999999997, 11.46, 1.9700000000000002, 2.7493082682291665" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
@@ -297,5 +297,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(5.6249975 : 15.25); (5.6249975 : 12.5585034179688); (4.625 : 12.5585034179688)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(5.6249975 : 15.25); (5.6249975 : 12.6546541341146); (4.625 : 12.6546541341146)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/HiveDataContext/DimClient/DimClient_FactClientInfo" />
       <nodes>
@@ -311,5 +311,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(1.59375 : 10.0689925130208); (1.59375 : 12.5585034179688); (2.625 : 12.5585034179688)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(1.59375 : 10.0689925130208); (1.59375 : 12.6546541341146); (2.625 : 12.6546541341146)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/HiveDataContext/DimUser/DimUser_FactClientInfo" />
       <nodes>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 12551)
@@ -4895,9 +4895,9 @@
 		private System.Guid _TaskId;
 		
-		private double _TotalRuntime;
-		
-		private double _TotalWaitingTime;
-		
-		private double _TotalTransferTime;
+		private long _TotalRuntime;
+		
+		private long _TotalWaitingTime;
+		
+		private long _TotalTransferTime;
 		
 		private int _NumCalculationRuns;
@@ -4921,5 +4921,5 @@
 		private string _Exception;
 		
-		private double _InitialWaitingTimeMs;
+		private long _InitialWaitingTimeMs;
 		
 		private System.Nullable<System.DateTime> _StartTime;
@@ -4935,9 +4935,9 @@
     partial void OnTaskIdChanging(System.Guid value);
     partial void OnTaskIdChanged();
-    partial void OnCalculatingTimeChanging(double value);
+    partial void OnCalculatingTimeChanging(long value);
     partial void OnCalculatingTimeChanged();
-    partial void OnWaitingTimeChanging(double value);
+    partial void OnWaitingTimeChanging(long value);
     partial void OnWaitingTimeChanged();
-    partial void OnTransferTimeChanging(double value);
+    partial void OnTransferTimeChanging(long value);
     partial void OnTransferTimeChanged();
     partial void OnNumCalculationRunsChanging(int value);
@@ -4961,5 +4961,5 @@
     partial void OnExceptionChanging(string value);
     partial void OnExceptionChanged();
-    partial void OnInitialWaitingTimeChanging(double value);
+    partial void OnInitialWaitingTimeChanging(long value);
     partial void OnInitialWaitingTimeChanged();
     partial void OnStartTimeChanging(System.Nullable<System.DateTime> value);
@@ -4994,6 +4994,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalRuntime", DbType="Float NOT NULL")]
-		public double CalculatingTime
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalRuntime", DbType="INT NOT NULL")]
+		public long CalculatingTime
 		{
 			get
@@ -5014,6 +5014,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalWaitingTime", DbType="Float NOT NULL")]
-		public double WaitingTime
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalWaitingTime", DbType="INT NOT NULL")]
+		public long WaitingTime
 		{
 			get
@@ -5034,6 +5034,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTransferTime", DbType="Float NOT NULL")]
-		public double TransferTime
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTransferTime", DbType="INT NOT NULL")]
+		public long TransferTime
 		{
 			get
@@ -5262,6 +5262,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_InitialWaitingTimeMs")]
-		public double InitialWaitingTime
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_InitialWaitingTimeMs", DbType="INT")]
+		public long InitialWaitingTime
 		{
 			get
@@ -5995,11 +5995,13 @@
 		private double _CpuUtilization;
 		
-		private double _TotalTimeIdle;
-		
-		private double _TotalTimeOffline;
-		
-		private double _TotalTimeUnavailable;
+		private long _TotalTimeIdle;
+		
+		private long _TotalTimeOffline;
+		
+		private long _TotalTimeUnavailable;
 		
 		private global::HeuristicLab.Services.Hive.DataAccess.SlaveState _SlaveState;
+		
+		private bool _IsAllowedToCalculate;
 		
 		private EntityRef<DimClient> _DimClient;
@@ -6029,12 +6031,14 @@
     partial void OnCpuUtilizationChanging(double value);
     partial void OnCpuUtilizationChanged();
-    partial void OnTotalTimeIdleChanging(double value);
-    partial void OnTotalTimeIdleChanged();
-    partial void OnTotalTimeOfflineChanging(double value);
-    partial void OnTotalTimeOfflineChanged();
-    partial void OnTotalTimeUnavailableChanging(double value);
-    partial void OnTotalTimeUnavailableChanged();
+    partial void OnIdleTimeChanging(long value);
+    partial void OnIdleTimeChanged();
+    partial void OnOfflineTimeChanging(long value);
+    partial void OnOfflineTimeChanged();
+    partial void OnUnavailableTimeChanging(long value);
+    partial void OnUnavailableTimeChanged();
     partial void OnSlaveStateChanging(global::HeuristicLab.Services.Hive.DataAccess.SlaveState value);
     partial void OnSlaveStateChanged();
+    partial void OnIsAllowedToCalculateChanging(bool value);
+    partial void OnIsAllowedToCalculateChanged();
     #endregion
 		
@@ -6219,6 +6223,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTimeIdle", DbType="Float NOT NULL")]
-		public double TotalTimeIdle
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTimeIdle", DbType="INT NOT NULL")]
+		public long IdleTime
 		{
 			get
@@ -6230,15 +6234,15 @@
 				if ((this._TotalTimeIdle != value))
 				{
-					this.OnTotalTimeIdleChanging(value);
+					this.OnIdleTimeChanging(value);
 					this.SendPropertyChanging();
 					this._TotalTimeIdle = value;
-					this.SendPropertyChanged("TotalTimeIdle");
-					this.OnTotalTimeIdleChanged();
-				}
-			}
-		}
-		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTimeOffline", DbType="Float NOT NULL")]
-		public double TotalTimeOffline
+					this.SendPropertyChanged("IdleTime");
+					this.OnIdleTimeChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTimeOffline", DbType="INT NOT NULL")]
+		public long OfflineTime
 		{
 			get
@@ -6250,15 +6254,15 @@
 				if ((this._TotalTimeOffline != value))
 				{
-					this.OnTotalTimeOfflineChanging(value);
+					this.OnOfflineTimeChanging(value);
 					this.SendPropertyChanging();
 					this._TotalTimeOffline = value;
-					this.SendPropertyChanged("TotalTimeOffline");
-					this.OnTotalTimeOfflineChanged();
-				}
-			}
-		}
-		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTimeUnavailable", DbType="Float NOT NULL")]
-		public double TotalTimeUnavailable
+					this.SendPropertyChanged("OfflineTime");
+					this.OnOfflineTimeChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_TotalTimeUnavailable", DbType="INT NOT NULL")]
+		public long UnavailableTime
 		{
 			get
@@ -6270,9 +6274,9 @@
 				if ((this._TotalTimeUnavailable != value))
 				{
-					this.OnTotalTimeUnavailableChanging(value);
+					this.OnUnavailableTimeChanging(value);
 					this.SendPropertyChanging();
 					this._TotalTimeUnavailable = value;
-					this.SendPropertyChanged("TotalTimeUnavailable");
-					this.OnTotalTimeUnavailableChanged();
+					this.SendPropertyChanged("UnavailableTime");
+					this.OnUnavailableTimeChanged();
 				}
 			}
@@ -6299,4 +6303,24 @@
 		}
 		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IsAllowedToCalculate", DbType="BIT")]
+		public bool IsAllowedToCalculate
+		{
+			get
+			{
+				return this._IsAllowedToCalculate;
+			}
+			set
+			{
+				if ((this._IsAllowedToCalculate != value))
+				{
+					this.OnIsAllowedToCalculateChanging(value);
+					this.SendPropertyChanging();
+					this._IsAllowedToCalculate = value;
+					this.SendPropertyChanged("IsAllowedToCalculate");
+					this.OnIsAllowedToCalculateChanged();
+				}
+			}
+		}
+		
 		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="DimClient_FactClientInfo", Storage="_DimClient", ThisKey="ClientId", OtherKey="Id", IsForeignKey=true)]
 		public DimClient DimClient
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Initialize Hive Database.sql
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Initialize Hive Database.sql	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Initialize Hive Database.sql	(revision 12551)
@@ -217,6 +217,6 @@
     [ResourceGroupId]  UNIQUEIDENTIFIER NULL,
     [ResourceGroup2Id] UNIQUEIDENTIFIER NULL,
-	[GroupName]        VARCHAR (MAX)    NULL,
-	[GroupName2]       VARCHAR (MAX)    NULL,
+    [GroupName]        VARCHAR (MAX)    NULL,
+    [GroupName2]       VARCHAR (MAX)    NULL,
     CONSTRAINT [PK_DimClient] PRIMARY KEY CLUSTERED ([Id] ASC)
 );
@@ -238,16 +238,17 @@
 );
 CREATE TABLE [statistics].[FactClientInfo] (
-    [ClientId]              UNIQUEIDENTIFIER NOT NULL,
-    [Time]                  DATETIME         NOT NULL,
-    [UserId]                UNIQUEIDENTIFIER NOT NULL,
-    [NumUsedCores]          INT              NOT NULL,
-    [NumTotalCores]         INT              NOT NULL,
-    [UsedMemory]            INT              NOT NULL,
-    [TotalMemory]           INT              NOT NULL,
-    [CpuUtilization]        FLOAT (53)       NOT NULL,
-    [SlaveState]			VarChar(15) 	 NOT NULL,
-    [TotalTimeIdle]         FLOAT (53)       NOT NULL,
-    [TotalTimeOffline]      FLOAT (53)       NOT NULL,
-    [TotalTimeUnavailable]  FLOAT (53)       NOT NULL,
+    [ClientId]             UNIQUEIDENTIFIER NOT NULL,
+    [Time]                 DATETIME         NOT NULL,
+    [UserId]               UNIQUEIDENTIFIER NOT NULL,
+    [NumUsedCores]         INT              NOT NULL,
+    [NumTotalCores]        INT              NOT NULL,
+    [UsedMemory]           INT              NOT NULL,
+    [TotalMemory]          INT              NOT NULL,
+    [CpuUtilization]       FLOAT (53)       NOT NULL,
+    [SlaveState]           VarChar(15)      NOT NULL,
+    [IdleTime]             INT              NOT NULL,
+    [OfflineTime]          INT              NOT NULL,
+    [UnavailableTime]      INT              NOT NULL,
+    [IsAllowedToCalculate] BIT              NOT NULL,
     CONSTRAINT [PK_FactClientInfo] PRIMARY KEY CLUSTERED ([ClientId] ASC, [Time] ASC, [UserId] ASC),
     CONSTRAINT [FK_FactClientInfo_DimTime] FOREIGN KEY ([Time]) REFERENCES [statistics].[DimTime] ([Time]),
@@ -255,24 +256,25 @@
     CONSTRAINT [FK_FactClientInfo_DimUser] FOREIGN KEY ([UserId]) REFERENCES [statistics].[DimUser] ([UserId])
 );
+
 CREATE TABLE [statistics].[FactTask] (
-    [TaskId]			   UNIQUEIDENTIFIER NOT NULL,
-    [CalculatingTime]	   FLOAT (53)       NOT NULL,
-    [WaitingTime]		   FLOAT (53)       NOT NULL,
-    [TransferTime]         FLOAT (53)       NOT NULL,
-    [NumCalculationRuns]   INT              NOT NULL,
-    [NumRetries]		   INT              NOT NULL,
-    [CoresRequired]		   INT              NOT NULL,
-    [MemoryRequired]	   INT              NOT NULL,
-    [Priority]			   INT              NOT NULL,
-    [LastClientId]		   UNIQUEIDENTIFIER NULL,
-    [JobId]				   UNIQUEIDENTIFIER NOT NULL,
-    [StartTime]            DATETIME         NULL,
-    [EndTime]			   DATETIME         NULL,
-    [TaskState]			   VARCHAR (30)     NOT NULL,
-    [Exception]			   VARCHAR (MAX)	NULL,
-    [InitialWaitingTime]   FLOAT (53)       NULL,
-    CONSTRAINT [PK_FactTask] PRIMARY KEY CLUSTERED ([TaskId] ASC),
-    CONSTRAINT [FK_FactTask_DimClient] FOREIGN KEY ([LastClientId]) REFERENCES [statistics].[DimClient] ([Id]),
-    CONSTRAINT [FK_FactTask_DimJob] FOREIGN KEY ([JobId]) REFERENCES [statistics].[DimJob] ([JobId])
+  [TaskId]             UNIQUEIDENTIFIER NOT NULL,
+  [CalculatingTime]    INT              NOT NULL,
+  [WaitingTime]        INT              NOT NULL,
+  [TransferTime]       INT              NOT NULL,
+  [NumCalculationRuns] INT              NOT NULL,
+  [NumRetries]         INT              NOT NULL,
+  [CoresRequired]      INT              NOT NULL,
+  [MemoryRequired]     INT              NOT NULL,
+  [Priority]           INT              NOT NULL,
+  [LastClientId]       UNIQUEIDENTIFIER NULL,
+  [JobId]		       UNIQUEIDENTIFIER NOT NULL,
+  [StartTime]          DATETIME         NULL,
+  [EndTime]            DATETIME         NULL,
+  [TaskState]          VARCHAR (30)     NOT NULL,
+  [Exception]          VARCHAR (MAX)    NULL,
+  [InitialWaitingTime] INT              NULL,
+  CONSTRAINT [PK_FactTask] PRIMARY KEY CLUSTERED ([TaskId] ASC),
+  CONSTRAINT [FK_FactTask_DimClient] FOREIGN KEY ([LastClientId]) REFERENCES [statistics].[DimClient] ([Id]),
+  CONSTRAINT [FK_FactTask_DimJob] FOREIGN KEY ([JobId]) REFERENCES [statistics].[DimJob] ([JobId])
 );
 
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 12551)
@@ -241,9 +241,10 @@
           UsedMemory = x.TotalMemory - x.FreeMemory,
           TotalMemory = x.TotalMemory,
-          CpuUtilization = x.CpuUtilization,
+          CpuUtilization = Math.Round(x.CpuUtilization, 2),
           SlaveState = x.SlaveState,
-          TotalTimeIdle = x.SlaveState == SlaveState.Idle && x.IsAllowedToCalculate ? duration : 0.0,
-          TotalTimeUnavailable = x.SlaveState == SlaveState.Idle && !x.IsAllowedToCalculate ? duration : 0.0,
-          TotalTimeOffline = x.SlaveState == SlaveState.Offline ? duration : 0.0
+          IdleTime = x.SlaveState == SlaveState.Idle && x.IsAllowedToCalculate ? duration : 0,
+          UnavailableTime = x.SlaveState == SlaveState.Idle && !x.IsAllowedToCalculate ? duration : 0,
+          OfflineTime = x.SlaveState == SlaveState.Offline ? duration : 0,
+          IsAllowedToCalculate = x.IsAllowedToCalculate
         }
       );
@@ -322,8 +323,8 @@
       public int CalculationRuns { get; set; }
       public int Retries { get; set; }
-      public double CalculatingTime { get; set; }
-      public double WaitingTime { get; set; }
-      public double TransferTime { get; set; }
-      public double InitialWaitingTime { get; set; }
+      public long CalculatingTime { get; set; }
+      public long WaitingTime { get; set; }
+      public long TransferTime { get; set; }
+      public long InitialWaitingTime { get; set; }
       public string Exception { get; set; }
       public DateTime? StartTime { get; set; }
